<?php

/**
 * The file that defines the core plugin class
 *
 * A class definition that includes attributes and functions used across both the
 * public-facing side of the site and the admin area.
 *
 * @link       https://orphic.ca
 * @since      1.0.0
 *
 * @package    Wb_Onboard
 * @subpackage Wb_Onboard/includes
 */

/**
 * The core plugin class.
 *
 * This is used to define internationalization, admin-specific hooks, and
 * public-facing site hooks.
 *
 * Also maintains the unique identifier of this plugin as well as the current
 * version of the plugin.
 *
 * @since      1.0.0
 * @package    Wb_Onboard
 * @subpackage Wb_Onboard/includes
 * @author     Orphic Inc. <contact@orphic.ca>
 */
class Wb_Onboard
{

  /**
   * The loader that's responsible for maintaining and registering all hooks that power
   * the plugin.
   *
   * @since    1.0.0
   * @access   protected
   * @var      Wb_Onboard_Loader    $loader    Maintains and registers all hooks for the plugin.
   */
  protected $loader;

  /**
   * The unique identifier of this plugin.
   *
   * @since    1.0.0
   * @access   protected
   * @var      string    $plugin_name    The string used to uniquely identify this plugin.
   */
  protected $plugin_name;

  /**
   * The current version of the plugin.
   *
   * @since    1.0.0
   * @access   protected
   * @var      string    $version    The current version of the plugin.
   */
  protected $version;

  /**
   * Define the core functionality of the plugin.
   *
   * Set the plugin name and the plugin version that can be used throughout the plugin.
   * Load the dependencies, define the locale, and set the hooks for the admin area and
   * the public-facing side of the site.
   *
   * @since    1.0.0
   */
  public function __construct()
  {
    if (defined('WB_ONBOARD_VERSION')) {
      $this->version = WB_ONBOARD_VERSION;
    } else {
      $this->version = '1.0.0';
    }
    $this->plugin_name = 'wb-onboard';

    $this->load_dependencies();
    $this->set_locale();
    $this->define_admin_hooks();
    $this->define_public_hooks();
  }

  /**
   * Load the required dependencies for this plugin.
   *
   * Include the following files that make up the plugin:
   *
   * - Wb_Onboard_Loader. Orchestrates the hooks of the plugin.
   * - Wb_Onboard_i18n. Defines internationalization functionality.
   * - Wb_Onboard_Admin. Defines all hooks for the admin area.
   * - Wb_Onboard_Public. Defines all hooks for the public side of the site.
   *
   * Create an instance of the loader which will be used to register the hooks
   * with WordPress.
   *
   * @since    1.0.0
   * @access   private
   */
  private function load_dependencies()
  {

    /**
     * The class responsible for orchestrating the actions and filters of the
     * core plugin.
     */
    require_once plugin_dir_path(dirname(__FILE__)) . 'includes/class-wb-onboard-loader.php';

    /**
     * The class responsible for defining internationalization functionality
     * of the plugin.
     */
    require_once plugin_dir_path(dirname(__FILE__)) . 'includes/class-wb-onboard-i18n.php';

    /**
     * The class responsible for defining all actions that occur in the admin area.
     */
    require_once plugin_dir_path(dirname(__FILE__)) . 'admin/class-wb-onboard-admin.php';

    /**
     * The class responsible for defining all actions that occur in the public-facing
     * side of the site.
     */
    require_once plugin_dir_path(dirname(__FILE__)) . 'public/class-wb-onboard-public.php';

    /**
     * The class responsible for defining all actions that occur in the api
     * side of the site.
     */
    require_once plugin_dir_path(dirname(__FILE__)) . 'feature/api/class-wb-api.php';

    /**
     * The class responsible for defining all actions that occur in the api
     * side of the site.
     */
    require_once plugin_dir_path(dirname(__FILE__)) . 'feature/api/class-wb-api-form.php';

    /**
     * The class responsible for handling icons in the API
     */
    require_once plugin_dir_path(dirname(__FILE__)) . 'feature/api/class-wb-api-icons.php';

    /**
     * The class responsible for leadership management in the API
     */
    require_once plugin_dir_path(dirname(__FILE__)) . 'feature/api/class-wb-api-leader.php';

    /**
     * The class responsible for defining all required files for the automatisation
     */
    require_once plugin_dir_path(dirname(__FILE__)) . 'feature/automatisations/automationRequire.php';

    /**
     * The class responsible for defining all actions that occur in the api
     * side of the site.
     */
    require_once plugin_dir_path(dirname(__FILE__)) . 'feature/api/tasks.php';

    /**
     * The class responsible for defining all actions that occur in the api
     * side of the site.
     */
    require_once plugin_dir_path(dirname(__FILE__)) . 'feature/api/connect-domaine.php';

    /**
     * The class responsible for defining all actions that occur in the api
     * side of the site.
     */
    require_once plugin_dir_path(dirname(__FILE__)) . 'service/class-wb-backup-service.php';

    /**
     * The class responsible for defining all actions that occur in the api
     * side of the site.
     */
    require_once plugin_dir_path(dirname(__FILE__)) . 'service/class-wb-leader-service.php';

    $this->loader = new Wb_Onboard_Loader();
  }

  /**
   * Define the locale for this plugin for internationalization.
   *
   * Uses the Wb_Onboard_i18n class in order to set the domain and to register the hook
   * with WordPress.
   *
   * @since    1.0.0
   * @access   private
   */
  private function set_locale()
  {

    $plugin_i18n = new Wb_Onboard_i18n();

    $this->loader->add_action('plugins_loaded', $plugin_i18n, 'load_plugin_textdomain');
  }

  /**
   * Register all of the hooks related to the admin area functionality
   * of the plugin.
   *
   * @since    1.0.0
   * @access   private
   */
  private function define_admin_hooks()
  {

    $plugin_admin = new Wb_Onboard_Admin($this->get_plugin_name(), $this->get_version());

    $this->loader->add_action('admin_enqueue_scripts', $plugin_admin, 'enqueue_styles');
    $this->loader->add_action('admin_enqueue_scripts', $plugin_admin, 'enqueue_scripts');

    $this->loader->add_action('admin_menu', $plugin_admin, 'wb_onboard_register_menu_page');

    $this->loader->add_filter('admin_body_class', $plugin_admin, 'wb_onboard_menu_page_add_classes');

    $this->loader->add_action('rest_api_init', $plugin_admin, 'wb_register_form_rest_api_routes');

    $this->loader->add_action('login_enqueue_scripts', $plugin_admin, 'wb_edit_login_form');
    $this->loader->add_filter('login_headerurl', $plugin_admin, 'wb_edit_login_logo_url');
    $this->loader->add_filter('login_headertext', $plugin_admin, 'wb_edit_login_logo_url_title');

    $this->loader->add_filter('show_admin_bar', $plugin_admin, 'wb_hide_wp_toolbar');

    $this->loader->add_action('current_screen', $plugin_admin, 'wb_redirect_onboarding_user');

    $this->loader->add_action('wp_dashboard_setup', $plugin_admin, 'register_wb_helper_widget');

    $this->loader->add_action('wp_ajax_wb_trigger_reset', $plugin_admin, 'handle_reset_ajax');
  }

  /**
   * Register all of the hooks related to the public-facing functionality
   * of the plugin.
   *
   * @since    1.0.0
   * @access   private
   */
  private function define_public_hooks()
  {

    $plugin_public = new Wb_Onboard_Public($this->get_plugin_name(), $this->get_version());
    $wb_api = new Wb_Api();
    $wb_api_form = new Wb_Api_Form();
    $tasks_api = new TasksAPI();
    $connect_domaine_api = new DomainConnectAPI();
    $wb_api_icons = new Wb_Api_Icons();
    $wb_api_leader = new Wb_Api_Leader();

    $this->loader->add_action('wp_enqueue_scripts', $plugin_public, 'enqueue_styles');
    $this->loader->add_action('wp_enqueue_scripts', $plugin_public, 'enqueue_scripts');

    $this->loader->add_action('login_enqueue_scripts', $plugin_public, 'wb_enqueue_login_styles');

    $this->loader->add_action('wp_before_admin_bar_render', $plugin_public, 'wb_customize_admin_bar');

    $this->loader->add_action('wp', $plugin_public, 'wb_block_frontend');


    $this->loader->add_action('rest_api_init', $wb_api, 'register_routes');
    $this->loader->add_action('rest_api_init', $wb_api_form, 'register_routes');
    $this->loader->add_action('rest_api_init', $tasks_api, 'register_routes');
    $this->loader->add_action('rest_api_init', $connect_domaine_api, 'register_routes');
    $this->loader->add_action('rest_api_init', $wb_api_icons, 'register_routes');
    $this->loader->add_action('rest_api_init', $wb_api_leader, 'register_routes');

    $this->loader->add_action('wp_footer', $plugin_public, 'wb_add_script_to_footer');
  }

  /**
   * Run the loader to execute all of the hooks with WordPress.
   *
   * @since    1.0.0
   */
  public function run()
  {
    $this->loader->run();
  }

  /**
   * The name of the plugin used to uniquely identify it within the context of
   * WordPress and to define internationalization functionality.
   *
   * @since     1.0.0
   * @return    string    The name of the plugin.
   */
  public function get_plugin_name()
  {
    return $this->plugin_name;
  }

  /**
   * The reference to the class that orchestrates the hooks with the plugin.
   *
   * @since     1.0.0
   * @return    Wb_Onboard_Loader    Orchestrates the hooks of the plugin.
   */
  public function get_loader()
  {
    return $this->loader;
  }

  /**
   * Retrieve the version number of the plugin.
   *
   * @since     1.0.0
   * @return    string    The version number of the plugin.
   */
  public function get_version()
  {
    return $this->version;
  }
}
